#ifndef _H_0E332DC14C06A8B4ED00D124CEDF6EA1_LaneBoundary_DCPS_H_
#define _H_0E332DC14C06A8B4ED00D124CEDF6EA1_LaneBoundary_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LaneBoundary_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LaneBoundary_TypeSupportInterface;

            typedef LaneBoundary_TypeSupportInterface * LaneBoundary_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundary_TypeSupportInterface> LaneBoundary_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LaneBoundary_TypeSupportInterface> LaneBoundary_TypeSupportInterface_out;


            class LaneBoundary_DataWriter;

            typedef LaneBoundary_DataWriter * LaneBoundary_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundary_DataWriter> LaneBoundary_DataWriter_var;
            typedef DDS_DCPSInterface_out < LaneBoundary_DataWriter> LaneBoundary_DataWriter_out;


            class LaneBoundary_DataReader;

            typedef LaneBoundary_DataReader * LaneBoundary_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundary_DataReader> LaneBoundary_DataReader_var;
            typedef DDS_DCPSInterface_out < LaneBoundary_DataReader> LaneBoundary_DataReader_out;


            class LaneBoundary_DataReaderView;

            typedef LaneBoundary_DataReaderView * LaneBoundary_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundary_DataReaderView> LaneBoundary_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LaneBoundary_DataReaderView> LaneBoundary_DataReaderView_out;

            struct LaneBoundary_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LaneBoundary_, struct LaneBoundary_Seq_uniq_> LaneBoundary_Seq;
            typedef DDS_DCPSSequence_var < LaneBoundary_Seq> LaneBoundary_Seq_var;
            typedef DDS_DCPSSequence_out < LaneBoundary_Seq> LaneBoundary_Seq_out;

            class  LaneBoundary_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LaneBoundary_TypeSupportInterface_ptr _ptr_type;
                typedef LaneBoundary_TypeSupportInterface_var _var_type;

                static LaneBoundary_TypeSupportInterface_ptr _duplicate (LaneBoundary_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundary_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundary_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundary_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundary_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LaneBoundary_TypeSupportInterface () {};
                ~LaneBoundary_TypeSupportInterface () {};
            private:
                LaneBoundary_TypeSupportInterface (const LaneBoundary_TypeSupportInterface &);
                LaneBoundary_TypeSupportInterface & operator = (const LaneBoundary_TypeSupportInterface &);
            };

            class  LaneBoundary_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LaneBoundary_DataWriter_ptr _ptr_type;
                typedef LaneBoundary_DataWriter_var _var_type;

                static LaneBoundary_DataWriter_ptr _duplicate (LaneBoundary_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundary_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundary_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundary_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundary_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LaneBoundary_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LaneBoundary_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LaneBoundary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LaneBoundary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LaneBoundary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LaneBoundary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LaneBoundary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LaneBoundary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LaneBoundary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LaneBoundary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LaneBoundary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneBoundary_& instance_data) = 0;

            protected:
                LaneBoundary_DataWriter () {};
                ~LaneBoundary_DataWriter () {};
            private:
                LaneBoundary_DataWriter (const LaneBoundary_DataWriter &);
                LaneBoundary_DataWriter & operator = (const LaneBoundary_DataWriter &);
            };

            class  LaneBoundary_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LaneBoundary_DataReader_ptr _ptr_type;
                typedef LaneBoundary_DataReader_var _var_type;

                static LaneBoundary_DataReader_ptr _duplicate (LaneBoundary_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundary_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundary_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundary_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundary_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LaneBoundary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LaneBoundary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LaneBoundary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneBoundary_& instance) = 0;

            protected:
                LaneBoundary_DataReader () {};
                ~LaneBoundary_DataReader () {};
            private:
                LaneBoundary_DataReader (const LaneBoundary_DataReader &);
                LaneBoundary_DataReader & operator = (const LaneBoundary_DataReader &);
            };

            class  LaneBoundary_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LaneBoundary_DataReaderView_ptr _ptr_type;
                typedef LaneBoundary_DataReaderView_var _var_type;

                static LaneBoundary_DataReaderView_ptr _duplicate (LaneBoundary_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundary_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundary_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundary_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundary_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LaneBoundary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LaneBoundary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LaneBoundary_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LaneBoundary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneBoundary_& instance) = 0;

            protected:
                LaneBoundary_DataReaderView () {};
                ~LaneBoundary_DataReaderView () {};
            private:
                LaneBoundary_DataReaderView (const LaneBoundary_DataReaderView &);
                LaneBoundary_DataReaderView & operator = (const LaneBoundary_DataReaderView &);
            };
        }

    }

}

#endif
