#ifndef _H_C9C978AC825B10F7F76AC12D6B04DA5B_ModuleState_DCPS_H_
#define _H_C9C978AC825B10F7F76AC12D6B04DA5B_ModuleState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ModuleState_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ModuleState_TypeSupportInterface;

            typedef ModuleState_TypeSupportInterface * ModuleState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ModuleState_TypeSupportInterface> ModuleState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ModuleState_TypeSupportInterface> ModuleState_TypeSupportInterface_out;


            class ModuleState_DataWriter;

            typedef ModuleState_DataWriter * ModuleState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ModuleState_DataWriter> ModuleState_DataWriter_var;
            typedef DDS_DCPSInterface_out < ModuleState_DataWriter> ModuleState_DataWriter_out;


            class ModuleState_DataReader;

            typedef ModuleState_DataReader * ModuleState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ModuleState_DataReader> ModuleState_DataReader_var;
            typedef DDS_DCPSInterface_out < ModuleState_DataReader> ModuleState_DataReader_out;


            class ModuleState_DataReaderView;

            typedef ModuleState_DataReaderView * ModuleState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ModuleState_DataReaderView> ModuleState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ModuleState_DataReaderView> ModuleState_DataReaderView_out;

            struct ModuleState_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ModuleState_, struct ModuleState_Seq_uniq_> ModuleState_Seq;
            typedef DDS_DCPSSequence_var < ModuleState_Seq> ModuleState_Seq_var;
            typedef DDS_DCPSSequence_out < ModuleState_Seq> ModuleState_Seq_out;

            class  ModuleState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ModuleState_TypeSupportInterface_ptr _ptr_type;
                typedef ModuleState_TypeSupportInterface_var _var_type;

                static ModuleState_TypeSupportInterface_ptr _duplicate (ModuleState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModuleState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ModuleState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModuleState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ModuleState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ModuleState_TypeSupportInterface () {};
                ~ModuleState_TypeSupportInterface () {};
            private:
                ModuleState_TypeSupportInterface (const ModuleState_TypeSupportInterface &);
                ModuleState_TypeSupportInterface & operator = (const ModuleState_TypeSupportInterface &);
            };

            class  ModuleState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ModuleState_DataWriter_ptr _ptr_type;
                typedef ModuleState_DataWriter_var _var_type;

                static ModuleState_DataWriter_ptr _duplicate (ModuleState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModuleState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ModuleState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModuleState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ModuleState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ModuleState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ModuleState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ModuleState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ModuleState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ModuleState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ModuleState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ModuleState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ModuleState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ModuleState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ModuleState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ModuleState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ModuleState_& instance_data) = 0;

            protected:
                ModuleState_DataWriter () {};
                ~ModuleState_DataWriter () {};
            private:
                ModuleState_DataWriter (const ModuleState_DataWriter &);
                ModuleState_DataWriter & operator = (const ModuleState_DataWriter &);
            };

            class  ModuleState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ModuleState_DataReader_ptr _ptr_type;
                typedef ModuleState_DataReader_var _var_type;

                static ModuleState_DataReader_ptr _duplicate (ModuleState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModuleState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ModuleState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModuleState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ModuleState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ModuleState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ModuleState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ModuleState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ModuleState_& instance) = 0;

            protected:
                ModuleState_DataReader () {};
                ~ModuleState_DataReader () {};
            private:
                ModuleState_DataReader (const ModuleState_DataReader &);
                ModuleState_DataReader & operator = (const ModuleState_DataReader &);
            };

            class  ModuleState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ModuleState_DataReaderView_ptr _ptr_type;
                typedef ModuleState_DataReaderView_var _var_type;

                static ModuleState_DataReaderView_ptr _duplicate (ModuleState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModuleState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ModuleState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModuleState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ModuleState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ModuleState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ModuleState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ModuleState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ModuleState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ModuleState_& instance) = 0;

            protected:
                ModuleState_DataReaderView () {};
                ~ModuleState_DataReaderView () {};
            private:
                ModuleState_DataReaderView (const ModuleState_DataReaderView &);
                ModuleState_DataReaderView & operator = (const ModuleState_DataReaderView &);
            };
        }

    }

}

#endif
